<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://www.sa-mods.info
 *
 * The Initial Developer of the Original Code is
 * wayne Mankertz.
 * Portions created by the Initial Developer are Copyright (C) 2009-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):Danial15
 *
 * ***** END LICENSE BLOCK ***** */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');

elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

global $db_prefix, $smcFunc;

// First load the SMF 2's Extra DB Functions
db_extend('packages');
	db_extend('extra');
	
	$query = $smcFunc['db_query']('', '
	SELECT COUNT(*)
	FROM {db_prefix}package_servers
	WHERE url = {string:sleepyarcade}',
	array(
		'sleepyarcade' => 'http://www.smfhispano.org',
	)
);
list ($count) = $smcFunc['db_fetch_row']($query);
if (empty($count))
{
	$smcFunc['db_insert']('insert',
		'{db_prefix}package_servers',
		array('name' => 'string', 'url' => 'string'),
		array('SMF Hispano', 'http://www.smfhispano.org'),
		array('id_server')
	);
}
	
	// Insert the default settings
$smcFunc['db_insert']('ignore', '{db_prefix}settings',
			array(
				'variable' => 'string',
				'value' => 'string'
			),
	array(
		array ('shopRegAmount' ,'100'),
		array ('shopBInterest' ,'2'),
		array ('shopwfee' ,'10'),
		array ('shopdfee' ,'10'),
		array ('shopdmin' ,'30'),
		array ('shopwmin' ,'30'),
		array ('shopdmax' ,'500'),
		array ('shopwmax' ,'500'),
		array ('shopprefix' ,''),
		array ('shopsurfix' ,' Credits'),
		array ('shopPointTopic' ,'5'),
		array ('shopPointPost' ,'3'),
		array ('shopPointWord' ,'5'),
		array ('shopPointChar' ,'1'),
		array ('shopPointLimit' ,'1000'),
		array ('shop_Enable_shop' ,'1'),
		array ('shop_Enable_gameroom' ,'1'),
		array ('shop_Enable_Bank' ,'1'),
		array ('shop_Enable_trade' ,'1'),
		array ('shop_Enable_Gift' ,'1'),
		array ('shop_Enable_Stats' ,'1'),
		array ('ShopCbEN' ,'0'),
		array ('ShopCbTitle' , 'Custom Block'),
		array ('ShopCbContent' , 'Add your own content to this custom block in the shop admin'),
		array ('ShopIpDis' ,'0'),
		array ('ShopIpDisMax' ,'50'),
		array ('ShopIpPos' ,'0'),
		array ('Shop_blocks' ,'1'),
		array ('Shop_blocks1' ,'1'),
		array ('Shop_blocks2' ,'0'),
	),
	array()
);
	
	$smcFunc['db_insert']('replace', '{db_prefix}settings',
		array(
			'variable' => 'string',
			'value' => 'string',
			),
	array(
		array ('shop_version' ,'1.0 RC1'),
		array ('shop_dev' ,0),
		array ('shop_build' ,'1'),
		array ('shop_build_date' ,'October 24, 2009'),
		),
		array()
	);
	
$smcFunc['db_add_column']('{db_prefix}boards', array(
	'name' => 'countMoney',
	'type' => 'tinyint',
	'size' => 1,
	'default' => '1',
	));	
	
	
$smcFunc['db_add_column']('{db_prefix}boards', array(
	'name' => 'shop_pertopic',
	'type' => 'decimal',
	'size' => '9,2',
	'default' => '0.00',
	));		
	
	
$smcFunc['db_add_column']('{db_prefix}boards', array(
	'name' => 'shop_perpost',
	'type' => 'decimal',
	'size' => '9,2',
	'default' => '0.00',
	));		
		

$smcFunc['db_add_column']('{db_prefix}boards', array(
	'name' => 'shop_bonuses',
	'type' => 'tinyint',
	'size' => 1,
	'default' => '1',
	));	
	
	// Add a column for to keep track trades [for the stats]
$smcFunc['db_add_column']('{db_prefix}members', 
array(
	'name' => 'tradeHis',
	'type' => 'tinyint',
	'default' => '0',
	));
	
	// Add a column for to keep track purcheses [for the stats]
$smcFunc['db_add_column']('{db_prefix}members', 
array(
	'name' => 'purchHis',
	'type' => 'decimal',
	'default' => '0.00',
	));
	
	// Add a column for money
$smcFunc['db_add_column']('{db_prefix}members', 
array(
	'name' => 'cash',
	'type' => 'decimal',
	'default' => '0.00',
	));
	
// Add a column for banked money
$smcFunc['db_add_column']('{db_prefix}members', 
array(
	'name' => 'cashBank',
	'type' => 'decimal',
	'default' => '0.00',
	));
	
	// Add a column for games pass
$smcFunc['db_add_column']('{db_prefix}members', 
array(
	'name' => 'games_pass',
	'type' => 'int',
	));
	
	
//check to see if they have cash
$result = $smcFunc['db_query']('','
	SELECT cash
	FROM {db_prefix}members
	LIMIT 1',
	array(
	)
);
list ($has_cash) = $smcFunc['db_fetch_row']($result);
$smcFunc['db_free_result']($result);

if (empty($has_cash))
{
	
	// give everyone 1000 as a start :)
	$smcFunc['db_query']('', "UPDATE {db_prefix}members SET `cash` = 1000");
	
}
	
	// add the users property table
$smcFunc['db_create_table']('{db_prefix}shop_property',
	array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'userid',
			'type' => 'int',
			'size' => 10,
		),	
		array(
			'name' => 'itemid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'trading',
			'type' => 'tinyint',
			'size' => 10,
		),
		array(
			'name' => 'tradecost',
			'type' => 'decimal',
			'size' => 10,
		),
		array(
			'name' => 'amtpaid',
			'type' => 'decimal',
			'size' => 10,
		),
		array(
			'name' => 'comment',
			'type' => 'tinytext',
		),
	),
	array(
		array(
			'name' => 'id',
			'type' => 'primary',
			'columns' => array('id'),
		),
	),
		array(),
	'ignore');
	
	$tables = $smcFunc['db_list_tables'](false, $db_prefix . 'shop_purchHis');
	 if (empty($tables)){
	// Purcuse history Table
$smcFunc['db_create_table']('{db_prefix}shop_purchHis',
	array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'itemid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'userid',
			'type' => 'int',
			'size' => 10,
		),	
		array(
			'name' => 'amtpaid',
			'type' => 'decimal',
			'size' => 10,
		),
		
	),
	array(
		array(
			'name' => 'id',
			'type' => 'primary',
			'columns' => array('id'),
		),
	),
	array(),
	'ignore');
	}
	// Item table
$smcFunc['db_create_table']('{db_prefix}shop_item',
	array(
		array(
			'name' => 'itemid',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 50,
		),	
		array(
			'name' => 'description',
			'type' => 'text',
		),
		array(
			'name' => 'price',
			'type' => 'decimal',
			'size' => '8,2',
			'default' => '0.00',
		),
		array(
			'name' => 'module',
			'type' => 'tinytext',
		),
		array(
			'name' => 'count',
			'type' => 'smallint',
			'size' => 6,
		),
		array(
			'name' => 'sold',
			'type' => 'smallint',
			'size' => 6,
		),
		array(
			'name' => 'info1',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'info2',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'info3',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'info4',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'input_needed',
			'type' => 'tinyint',
			'size' => 1,
			'default' => 0,
		),
		array(
			'name' => 'can_use_item',
			'type' => 'tinyint',
			'size' => 1,
			'default' => 0,
		),
		array(
			'name' => 'delete_after_use',
			'type' => 'tinyint',
			'size' => 1,
			'default' => 0,
		),
		array(
			'name' => 'image',
			'type' => 'tinytext',
			'null' => true,
		),
		array(
			'name' => 'catid',
			'type' => 'smallint',
			'size' => 6,
			'default' => 0,
		),
		array(
			'name' => 'status',
			'type' => 'text',
		),
	),
	array(
		array(
			'name' => 'itemid',
			'type' => 'primary',
			'columns' => array('itemid'),
		),
	),
	array(),
	'ignore');
	
	// Create The Category table
$smcFunc['db_create_table']('{db_prefix}shop_category',
	array(
		array(
			'name' => 'catid',
			'type' => 'smallint',
			'size' => 5,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 50,
		),	
		array(
			'name' => 'image',
			'type' => 'tinytext',
			'null' => true,
		),
		array(
			'name' => 'description',
			'type' => 'text',
		),	
		array(
			'name' => 'count',
			'type' => 'int',
			'size' => 10,
		),
	),
	array(
		array(
			'name' => 'catid',
			'type' => 'primary',
			'columns' => array('catid'),
		),
	),
	array(),
	'ignore');

// check to see if items exsist	
$result = $smcFunc['db_query']('','
	SELECT itemid
	FROM {db_prefix}shop_item
	LIMIT 1',
	array(
	)
);
list ($has_items) = $smcFunc['db_fetch_row']($result);
$smcFunc['db_free_result']($result);

if (empty($has_items))
{
	// Insert shop defult items
 $smcFunc['db_insert']('ignore',
            '{db_prefix}shop_item',

	// Fields
	array(
		'name' => 'string',
		'description' => 'string',
		'price' => 'float',
		'count' => 'int',
		'image' => 'string',
		'module' => 'string',
		'info1' => 'int',
		'info2' => 'int',
		'input_needed' => 'int',
		'can_use_item' => 'int',
		'delete_after_use' => 'int',
		'catid' => 'int',
		'status' => 'int',
		),
	
	// Values
	array(
		// testitem
		array(
			'name' => 'Test Item',
			'description' => 'Just a test item!',
			'price' => 10.00,
			'count' => 50,
			'image' => 'Airplane.gif',
			'module' => 'testitem',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 0,
			'can_use_item' => 0,
			'delete_after_use' => 0,
			'catid' => 1,
			'status' => 1,
			),
		
		// RandomMoney
		array(
			'name' => 'Random Money',
			'description' => 'Get a random amount of money, between -190 and 190!',
			'price' => 75,
			'count' => 50,
			'image' => 'Bear.gif',
			'module' => 'RandomMoney',
			'info1' => -190,
			'info2' => 190,
			'input_needed' => 0,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
			
		// AddToPostCount
		array(
			'name' => 'Add 100 to Post Count',
			'description' => 'Increase your Post Count by 100!',
			'price' => 50,
			'count' => 50,
			'image' => 'Boardarrow.gif',
			'module' => 'AddToPostCount',
			'info1' => 100,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),

		// IncreaseKarma
		array(
			'name' => 'Increase Karma',
			'description' => 'Increase your Karma by 5',
			'price' => 100,
			'count' => 50,
			'image' => 'Breadandbutter.gif',
			'module' => 'IncreaseKarma',
			'info1' => 5,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),

		// ChangeUsername
		array(
			'name' => 'Change Username',
			'description' => 'Change your Username!',
			'price' => 50,
			'count' => 50,
			'image' => 'Claspknife.gif',
			'module' => 'ChangeUsername',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),

		// ChangeUserTitle
		array(
			'name' => 'Change User Title',
			'description' => 'Change your User Title',
			'price' => 50,
			'count' => 50,
			'image' => 'Clip.gif',
		    'module' => 'ChangeUserTitle',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
			
		// IncreaseTimeLoggedIn
		array(
			'name' => 'Increase Total Time',
			'description' => 'Increase your total time logged in by 12 hours.',
			'price' => 50,
			'count' => 50,
			'image' => 'Compactdiscs.gif',
			'module' => 'IncreaseTimeLoggedIn',
			'info1' => 43200,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
			
		// StickyTopic
		array(
			'name' => 'Sticky Topic',
			'description' => 'Make any one of your topics a sticky!',
			'price' => 400,
			'count' => 50,
			'image' => 'Dousojin.gif',
			'module' => 'StickyTopic',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),

		// StickyTopic
		array(
			'name' => 'Steal Credits',
			'description' => 'Try to steal credits from another member!',
			'price' => 50,
			'count' => 50,
			'image' => 'Dutchoven.gif',
			'module' => 'Steal',
			'info1' => 40,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
			
		// Rock
		array(
			'name' => 'Rock',
			'description' => 'Well... It does nothing',
			'price' => 5,
			'count' => 50,
			'image' => 'Dxtwoburner.gif',
			'module' => 'Rock',
			'info1' => 40,
			'info2' => 0,
			'input_needed' => 0,
			'can_use_item' => 0,
			'delete_after_use' => 0,
			'catid' => 1,
			'status' => 1,
			),
			
		// ChangeDisplayName
		array(
			'name' => 'Change Display Name',
			'description' => 'Change your display name!',
			'price' => 5,
			'count' => 50,
			'image' => 'Figure.gif',
			'module' => 'ChangeDisplayName',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
			
			// gamespass
		array(
			'name' => 'Games Room Pass',
			'description' => 'Allows access to Games Room for xxx days',
			'price' => 50,
			'count' => 50,
			'image' => 'Figure.gif',
			'module' => 'gamespass',
			'info1' => 30,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
		// ChangeOtherTitle
		array(
			'name' => 'Change Other\'s Title',
			'description' => 'Change someone else\'s title',
			'price' => 200,
			'count' => 50,
			'image' => 'Controller.gif',
			'module' => 'ChangeOtherTitle',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
		// DecreasePost
		array(
			'name' => 'Decrease Posts by 100',
			'description' => 'Decrease <i>Someone else\'s</i> post count by 100!',
			'price' => 200,
			'count' => 50,
			'image' => 'Darkbeer.gif',
			'module' => 'DecreasePost',
			'info1' => 0,
			'info2' => 0,
			'input_needed' => 1,
			'can_use_item' => 1,
			'delete_after_use' => 1,
			'catid' => 1,
			'status' => 1,
			),
		),
	array());
}

//check to see if default cat exsists
	$result = $smcFunc['db_query']('','
	SELECT catid
	FROM {db_prefix}shop_category
	LIMIT 1',
	array(
	)
);
list ($has_cat) = $smcFunc['db_fetch_row']($result);
$smcFunc['db_free_result']($result);

if (empty($has_cat))
{
	
	// insert the default cat
	$smcFunc['db_insert']('ignore',
            '{db_prefix}shop_category',
            array(
                'name' => 'string',
				'image' => 'string',
            ),
            array(
                'Default',
				'Boardarrow.gif',
            ),
			array()
        );
	
}

add_integration_function('integrate_pre_include', '$sourcedir/shop2/ShopHooks.php');
add_integration_function('integrate_actions', 'Shop_actions');
add_integration_function('integrate_load_permissions', 'Shop_load_permissions');
add_integration_function('integrate_menu_buttons', 'Shop_menu_buttons');
add_integration_function('integrate_admin_areas', 'Shop_admin_areas');
?>