<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://www.sa-mods.info
 *
 * The Initial Developer of the Original Code is
 * wayne Mankertz.
 * Portions created by the Initial Developer are Copyright (C) 2009-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):Danial15
 *
 * ***** END LICENSE BLOCK ***** */

// If not in smf then this could be a hacking attempt?
if (!defined('SMF'))
      die('Hacking attempt...');
	  
	global $sourcedir, $scripturl;
	require_once($sourcedir . '/shop2/Shop_db.php');
	require_once($sourcedir . '/shop2/Subs_Shop.php');
	
function Shop()
{
	// Must global it otherwise we get erros
	global $txt, $modSettings, $context, $scripturl;
	
     // Deny Guest Regardless of Permissions
	 is_not_guest($txt['cannot_view_shop']);
	 // Do we have permission to veiw?
     isAllowedTo('view_shop'); 
     // Load the language strings
	 loadLanguage('Shop');
	 // Load the template.
	 loadTemplate('Shop');

	// Here's our little sub-action array.
	$subActions = array(
		'main' => 'Shop_main',
		'buy' => 'Shop_view',
		'inventory' => 'shop_Inventory',
		'inventory2' => 'shop_Inventory',
		'bank' => 'shop_Bank',
		'gift' => 'shop_Gift',
		'use' => 'shop_use',
		'use2' => 'shop_use',
		'use3' => 'shop_use',
		'trade' => 'shop_trade',
		'trade_sell' => 'shop_trade',
		'trade_sell2' => 'shop_trade',
		'trade_buy' => 'shop_trade',
		'trade_stop' => 'shop_trade',
		'gameroom' => 'Shop_Game',
		'stats' => 'stats_shop',
		'owners' => 'shop_owners',
		
	);
	// Setup their permissions
		    $allowedtrade = allowedTo('view_trade');
			$allowedshop = allowedTo('view_shop');
			$allowedgames = allowedTo('view_gameroom');
			$allowedbank = allowedTo('view_bank');
			$allowedgift = allowedTo('view_gift');
			$allowedotherinv = allowedTo('view_othersinv');
			$allowedbuy = allowedTo('view_buy');
	
	// the menu links array
	$context['tab_links'] = array();
	
	$context['tab_links'][] = array('action' => 'main',
									'label' =>  $txt['shop_tab_home']);
	// Is the user allowed to buy items
	if ($allowedbuy)								
	$context['tab_links'][] = array('action' => 'buy',
									'label' =>  $txt['shop_tab_buy']);
									
	// If you cant buy they wont be needing this so we use the shop by permission
	if ($allowedbuy)								
	$context['tab_links'][] = array('action' => 'inventory',
									'label' =>  $txt['shop_tab_inv']);
	
	// Is the user allowed to see other users inventory
	if ($allowedotherinv)
	$context['tab_links'][] = array('action' => 'inventory2',
									'label' =>  $txt['shop_tab_invm']);
	
	// is the gift shop enabled?
	if($modSettings['shop_Enable_Gift']){
	// Is the user allowed to send gifts
	if ($allowedgift)									
    $context['tab_links'][] = array('action' => 'gift',
									'label' => $txt['shop_tab_sg']);	
									}
	//Is the bank enabled?
	if($modSettings['shop_Enable_Bank']){
	// Is the user allowed to use the bank?
	if ($allowedbank)								
    $context['tab_links'][] = array('action' => 'bank',
									'label' => $txt['shop_tab_bank']);	
									}
	// Is the trade center enabled?
	if($modSettings['shop_Enable_trade']){
	// Is the user allowed to trade?
	if ($allowedtrade)								
    $context['tab_links'][] = array('action' => 'trade',
									'label' => $txt['shop_tab_trade']);
									}
	//Is the games room enabled?
	if($modSettings['shop_Enable_gameroom']){
	// Is the user allowed to use the games room
	if ($allowedgames)									
    $context['tab_links'][] = array('action' => 'gameroom',
									'label' => $txt['shop_tab_gr']);										
}
   //Is the shop stats enabled?
    if($modSettings['shop_Enable_Stats']){
    $context['tab_links'][] = array('action' => 'stats',
									'label' => $txt['shop_Stats']);
}
	
	// Default the sub-action to 'affiliates_veiw'.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'main';
	
	// Set title and default sub-action.
	$context['page_title'] = $txt['shop'];
	$context['sub_action'] = $_REQUEST['sa'];
	
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop',
		'name' => $txt['shop_tab_main'],
		);

	// Call the right function for this sub-acton.
	$subActions[$_REQUEST['sa']]();
}
 
function stats_shop() 
{
 global $context, $smcFunc, $shop, $txt, $scripturl;
$context['sub_template']  = 'stats';
$context['page_title'] = $txt['shop_Stats'];
shop_stats();	
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=stats',
		'name' => $txt['shop_Stats'],
		);
}
		
function Shop_main() {

 global $context, $smcFunc, $txt, $scripturl;

shop_mainv();

	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=main',
		'name' => $txt['shop_tab_home'],
		);

}
	
function Shop_view() {

// Must global it otherwise we get erros
   global $context, $user_info, $smcFunc, $shop, $txt, $scripturl;
 	
	// Do we have permission to veiw?
      isAllowedTo('view_buy'); 
	
	$context['sub_template']  = 'shop';
	$context['page_title'] = $txt['shop_buyi'];
	
	$id = !empty($_GET['itemid']) ? (int) $_GET['itemid'] : 0;
	
	$row = shop_getcatid();
	
	if(!isset($_GET['cat']))
		$_GET['cat'] = $row['catid'];
	
	if(isset($_GET['buy'])) 
	{
		$userid = $context['user']['id'];
		
		$iteminfo = shop_iteminfo($id,'');
		
		// check count
		if($iteminfo['count'] <= 0)
			$shop['shop_message'] = $txt['shop_hack'];
		else
		{
			// check money
			$cash = shop_Cash($userid) - $iteminfo['price'];
			if($cash >= 0)
			{
				//do
				shop_saveitems($userid, $id, 'add', '', 'bought');
				shop_saveitems($userid, $id, 'purchhism', '', 'bought');
				shop_saveitems('', $id, 'sold', 1, '');
				shop_saveitems('', $id, 'minus', 1, '');
				shop_saveitems($userid, $id, 'purchhismember', 1, '');
		
				shop_doCash($userid, $cash);
				$shop['shop_message'] = $txt['shop_shop_successpurchase'];
			}
			else
			{
				$shop['shop_message'] = $txt['shop_shop_lowmoney'];
			}
		}
	}
	
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=buy',
		'name' => $txt['shop_tab_buy'],
		);
}

function shop_Inventory() 
{

	global $context, $userid, $smcFunc, $txt, $shop, $scripturl;
	 
	$userid = $context['user']['id'];
	$_POST['thename'] = !empty($_POST['thename']) ? $smcFunc['htmlspecialchars']($_POST['thename'], ENT_QUOTES) : '';
	$id = !empty($_GET['next2']) ? (int) $_GET['next2'] : 0;
	
if($_REQUEST['sa']=="inventory2") 
	 
 $context['sub_template'] = 'inventory2';
 $context['page_title'] = $txt['shop_inventory2'];
 
 if($_REQUEST['sa']=="inventory2") {
 // Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=inventory2',
		'name' => $txt['shop_tab_invm'],
		);
}
 
	if(isset($_GET['next']))
	{
		if(isset($_POST['thename']))
		$_SESSION['just_posted_name'] = true;
		$_SESSION['name_posted'] = $_POST['thename'];
			$userid = shop_UserId($smcFunc['htmlspecialchars']($_POST['thename'], ENT_QUOTES));
		if(!isset($userid)) 
		{
			$shop['inv_message'] = $txt['shop_inv_nouser'];
		}
	}
	if(isset($_GET['next2']))
	{
	$_SESSION['just_posted_name'] = true;
		if(isset($id))
			$userid = shop_UserId($_GET['next2']);
		if(!isset($userid)) 
		{
			$shop['inv_message'] = $txt['shop_inv_nouser'];
		}
	}

	
if($_REQUEST['sa']=="inventory") 

 $context['sub_template'] = 'inventory';
 $context['page_title'] = $txt['shop_inventory'];
 
 if($_REQUEST['sa']=="inventory") {
 	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=inventory',
		'name' => $txt['shop_tab_inv'],
		);
}

if(isset($_GET['discard']))
	{
		$id = !empty($_GET['item']) ? (int) $_GET['item'] : 0;
        $userid = !empty($_GET['userid']) ? (int) $_GET['userid'] : 0;
		
		if(shop_own($userid, $id))
			shop_saveitems($userid, $id, 'remove', '', '');
		
		
	}
	
}	

function shop_Bank() {

	global $context, $modSettings, $txt, $user_info, $scripturl;
	global $shop;
	
	// Do we have permission to veiw?
      isAllowedTo('view_bank'); 
	  
	$context['sub_template']  = 'bank';
	$context['page_title'] = $txt['shop_bank'];
	
	$userid = $context['user']['id'];
	
	$cash = $user_info['cash'];
	$cashBank = $user_info['cashBank'];	
	
	if(isset($_GET['banking']))	
	{
		$amount = (float) $_POST['amount'];
		if ($_POST['type'] == 'deposit') 
		{
			if (($amount + $modSettings['shopdfee']) > $cash)
			$shop['bank_message'] = $txt['shop_bank_notmuch'];
			elseif ($amount <= 0)
			$shop['bank_message'] = $txt['shop_bank_negative'];
			elseif ($amount < $modSettings['shopdmin'])
			$shop['bank_message'] = sprintf($txt['shop_bank_toolow'], formatCash($modSettings['shopdmin']));
			elseif ($amount > $modSettings['shopdmax'])
			$shop['bank_message'] = sprintf($txt['shop_bank_toohigh'], formatCash($modSettings['shopdmax']));
			else 
			{
				$cash -= ($amount + $modSettings['shopdfee']);
				$cashBank += $amount;
			
				shop_doCash($userid, $cash);
				shop_CashBank($userid, $cashBank);

				$shop['bank_message'] = sprintf($txt['shop_bank_deposited'], $amount);
			}
		}
		elseif ($_POST['type'] == 'withdraw')
		{
			if (($amount + $modSettings['shopwfee']) > $cashBank)
			$shop['bank_message'] = $txt['shop_bank_notmuch2'];
			elseif ($amount <= 0)
			$shop['bank_message'] = $txt['shop_bank_negative'];
			elseif ($amount < $modSettings['shopwmin'])
			$shop['bank_message'] = sprintf($txt['shop_bank_toolow2'], formatCash($modSettings['shopwmin']));
			elseif ($amount > $modSettings['shopwmax'])
			$shop['bank_message'] = sprintf($txt['shop_bank_toolow2'], formatCash($modSettings['shopwmax']));			
			else 
			{
				$cashBank -= ($amount + $modSettings['shopwfee']);
				$cash += $amount;
			
				shop_doCash($userid, $cash);
				shop_CashBank($userid, $cashBank);

				$shop['bank_message'] = sprintf($txt['shop_bank_withdrew'], $amount);
			}
		}
	}
	
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=main',
		'name' => $txt['shop_tab_bank'],
		);
}

function shop_Gift() {

	global $context, $smcFunc, $txt, $newuser, $shop, $scripturl;
	
	// Do we have permission to veiw?
      isAllowedTo('view_gift'); 
	
	$context['sub_template']  = 'gift';
	$context['page_title'] = $txt['shop_tab_sg'];
	
	$shop['gift_message'] = '';
	
	$_POST['thename'] = !empty($_POST['thename']) ? $smcFunc['htmlspecialchars']($_POST['thename'], ENT_QUOTES) : '';
	$theamount = !empty($_POST['theamount']) ? (int) $_POST['theamount'] : 0;
	$theitem = !empty($_POST['theitem']) ? $smcFunc['htmlspecialchars']($_POST['theitem'], ENT_QUOTES) : '';
	send_get_items();
	// if user sending gift, then
	if(isset($_GET['send'])) 
	{
		// check username blank
		if(empty($_POST['thename']))
			$shop['gift_message'] .= $txt['shop_gift_noinput'].'<br />';
		else
		{
			// check username exist
			if($newuser = shop_UserId($_POST['thename']))
			{
				// check money blank
				if(!empty($theamount))
				{
					// check money
					$cash = shop_Cash($context['user']['id']) - $theamount;
					if($cash >= 0)
					{
						// transfer
						shop_doCash($context['user']['id'], $cash);
						shop_doCash($newuser, shop_Cash($newuser) + $theamount);
						$shop['gift_message'] .= $txt['shop_gift_donemoney'].'<br />';
						sendpm_money_gift();
					}
					else
					{
						$shop['gift_message'] .= $txt['shop_gift_nomoney'].'<br />';
					}
				}
				// check item blank
				if(!empty($theitem))
				{
					// check item
					if(shop_own($context['user']['id'], $theitem))
					{
						// transfer
						shop_saveitems($newuser, shop_iteminfo('',$theitem), 'add', '', 'from '.$context['user']['name']);
						shop_saveitems($context['user']['id'], $_POST['theitem'], 'remove', '', '');
						$shop['gift_message'] .= $txt['shop_gift_doneitem'].'<br />';
						sendpm_item_gift();
					}
					else
					{
						$shop['gift_message'] .= $txt['shop_gift_noitem'].'<br />';
					}
				}
			}
			// user not exist
			else
			{
				$shop['gift_message'] = $txt['shop_gift_nouser'].'<br />';
			}
		}
		$shop['gift_message'] .= '<br />';
	}
	
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=gift',
		'name' => $txt['shop_tab_sg'],
		);
		
}


function shop_use() {

global  $user_info, $item_info, $txt, $sourcedir, $scripturl, $context, $smcFunc;
if ($_REQUEST['sa'] == 'use')
{
// Make sure input was numeric
	$_GET['item'] = (int) $_GET['item'];
	
	//TODO add the database stuff to shop_db.php
	// Get the item's information
	$result = $smcFunc['db_query']('', '
		SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
			it.info4, inv.userid
		FROM {db_prefix}shop_property AS inv
         INNER JOIN {db_prefix}shop_item AS it ON (it.itemid = inv.itemid)
        WHERE inv.id = {int:id}
		LIMIT 1',
		array(
			'id' => $_GET['item'],
		));

	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
	// Trying to use other person's item? Nope, not here ;)
	if ($row['userid'] !== $user_info['id'])
		fatal_lang_error('shop_use_others_item2');
	// If the item is unusable
	if ($row['can_use_item'] == false)
		fatal_lang_error('shop_unusable');

	// Show the 'Item Requires Input' message, and start the form
	// TODO: Create seperate function in template for this? Current method is ugly.
	$context['shop_buy_message'] = '
		' . $txt['shop_input'] . '<br />
		 <form action="' . $scripturl . '?action=shop;sa=use3;item=' . $_GET['item'] . '" method="post">';

	// Additional info, just in case it's needed in getUseInput() function
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	// Include the item engine...
	require($sourcedir . '/shop2/item_engine.php');
	//... and the actual item.
	require($sourcedir . '/shop2/items/' . $row['module'] . '.php');
	// Create the item, ...
	eval('$temp = new item_' . $row['module'] . ';');
	// ...get the input required...
	$context['shop_buy_message'] .= $temp->getUseInput();
	// ... and show the submit button!
	$context['shop_buy_message'] .= '<br /><input type="submit" value="' . $txt['shop_use'] . '"></form>';
	
	// The shop action
	$context['shop_do'] = 'use';
	// Set the page title
	// Use the 'message' template
	$context['sub_template'] = 'message';
}
// Inv3 - Final stages of using the item
elseif ($_REQUEST['sa'] == 'use2')
{

	// Make sure input is numeric
	$_GET['item'] = (int) $_GET['item'];
	
	//TODO add the database stuff to shop_db.php
	// Get the item's information
	$result = $smcFunc['db_query']('', '
		SELECT it.module, it.can_use_item, it.delete_after_use, 
			it.info1, it.info2, it.info3, it.info4, inv.userid
		FROM {db_prefix}shop_property AS inv
		 INNER JOIN {db_prefix}shop_item AS it ON (it.itemid = inv.itemid)
		WHERE inv.id = {int:id}
		LIMIT 1',
		array(
			'id' => $_GET['item'],
		));

	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
	// Trying to use someone else's item? Nice try! :P
	if ($row['userid'] !== $user_info['id'])
		fatal_lang_error('shop_use_others_item2');
	// Sorry, item is a rock (unusable)
	elseif ($row['can_use_item'] == false)
		fatal_lang_error('shop_unusable');

	// Additional information used by the item (entered by admin when adding item)
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	// Require the item engine ...
	require($sourcedir . '/shop2/item_engine.php');
	// ... and the actual item.
	require($sourcedir . '/shop2/items/' . $row['module'] . '.php');

	// Create an instance of the item
	eval('$temp = new item_' . $row['module'] . ';');
	// Now, do the actual action!
	$context['shop_buy_message'] = $temp->onUse();
	// And show the 'Back to Inventory' link
	$context['shop_buy_message'] .= '
			<br /><br /><a href="' . $scripturl . '?action=shop;sa=inventory">' . $txt['shop_back2inv'] . '</a>';

	// If we got here, everything worked OK.
	//TODO add the database stuff to shop_db.php
	// If we have to, remove the item from the user's inventory
	if ($row['delete_after_use'] == 1)
		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}shop_property
			WHERE id = {int:id}
			LIMIT 1',
			array(
				'id' => $_GET['item'],
			));

	// The shop action
	$context['shop_do'] = 'use';
	// Set the page title
	//$context['page_title'] = $txt['shop'] . ' - ' . $txt['shop_yourinv'];						
	// Use the message template
	$context['sub_template'] = 'message';
}
elseif ($_REQUEST['sa'] == 'use3')
{

	// Make sure input is numeric
	$_GET['item'] = (int) $_GET['item'];
	
	//TODO add the database stuff to shop_db.php
	// Get the item's information
	$result = $smcFunc['db_query']('', '
		SELECT it.module, it.can_use_item, it.delete_after_use, 
			it.info1, it.info2, it.info3, it.info4, inv.userid
		FROM {db_prefix}shop_property AS inv
          INNER JOIN {db_prefix}shop_item AS it ON (it.itemid = inv.itemid)
        WHERE inv.id = {int:id}

		LIMIT 1',
		array(
			'id' => $_GET['item'],
		));

	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
	// Trying to use someone else's item? Nice try! :P
	if ($row['userid'] !== $user_info['id'])
		fatal_lang_error('shop_use_others_item2');
	// Sorry, item is a rock (unusable)
	elseif ($row['can_use_item'] == false)
		fatal_lang_error('shop_unusable');

	// Additional information used by the item (entered by admin when adding item)
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	// Require the item engine ...
	require($sourcedir . '/shop2/item_engine.php');
	// ... and the actual item.
	require($sourcedir . '/shop2/items/' . $row['module'] . '.php');

	// Create an instance of the item
	eval('$temp = new item_' . $row['module'] . ';');
	// Now, do the actual action!
	$context['shop_buy_message'] = $temp->onUse();
	// And show the 'Back to Inventory' link
	$context['shop_buy_message'] .= '
			<br /><br /><a href="' . $scripturl . '?action=shop;sa=inventory">' . $txt['shop_back2inv'] . '</a>';

	//TODO add the database stuff to shop_db.php
	// If we got here, everything worked OK.
	// If we have to, remove the item from the user's inventory
	if ($row['delete_after_use'] == 1)
		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}shop_property
			WHERE id = {int:id}
			LIMIT 1',
			array(
				'id' => $_GET['item'],
			));

	// The shop action
	$context['shop_do'] = 'use';
	// Set the page title				
	// Use the message template
	$context['sub_template'] = 'message';
}

// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=use',
		'name' => $txt['shop_use'],
		);
}

function Shop_trade()
{
	global  $user_info, $id_member, $row, $item_info, $txt, $sourcedir, $scripturl, $context, $smcFunc;
	if ($_REQUEST['sa'] == 'trade')
{
	// Do we have permission to veiw?
      isAllowedTo('view_trade'); 
	  
	$context['shop_trade_items'] = array();
	$alternating = 'windowbg2';
	//TODO add the database stuff to shop_db.php
	// Get all the items in the trade centre
	$result = $smcFunc['db_query']('', '
		SELECT it.name, it.description, it.image, inv.itemid, m.real_name, inv.tradecost
		FROM {db_prefix}shop_property AS inv
		INNER JOIN {db_prefix}shop_item AS it ON (it.itemid = inv.itemid)
		INNER JOIN {db_prefix}members AS m ON (m.id_member = inv.userid)
		WHERE inv.trading = 1 ', array());
	// Loop through all items
	while ($row = $smcFunc['db_fetch_assoc']($result))
		$context['shop_trade_items'][] = array(
			'id' => $row['itemid'],
			'name' => $row['name'],
			'desc' => $row['description'],
			'image' => $row['image'],
			'realName' => $row['real_name'],
			'tradecost' => $row['tradecost'],
		);
	$smcFunc['db_free_result']($result);
	
	// Set the page title
	$context['page_title'] = $txt['shop_trade'];
	// Use the trade centre sub template
	$context['sub_template'] = 'userTrade';
	loadTemplate('Shop');
	
}
// If they're buying an item from the trade centre
elseif ($_REQUEST['sa'] == 'trade_buy')
{

	// Make sure item ID was numeric
	$_GET['id'] = (int) $_GET['id'];
		//TODO add the database stuff to shop_db.php			
	// Get information on the item in question	
	$result = $smcFunc['db_query']('', '
		SELECT
			it.name,
			inv.tradecost, inv.trading, inv.userid,
			m.real_name, m.email_address, m.cash, m.tradeHis
		FROM {db_prefix}shop_property AS inv
		INNER JOIN {db_prefix}shop_item AS it ON (inv.itemid = it.itemid)
		INNER JOIN {db_prefix}members AS m ON (inv.userid = m.id_member)
		WHERE inv.itemid = {int:id}
		LIMIT 1',
		array(
			'id' => $_GET['id'],
		));
						
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	$userid = $context['user']['id'];
	// If this item is not for trade
	if ($row['trading'] != 1)
		$context['shop_buy_message'] = $txt['shop_no_sale'];
	// If they can't afford it
	elseif (shop_Cash($userid) < $row['tradecost'])
		$context['shop_buy_message'] = sprintf($txt['shop_not_enough_money'], $cost - shop_Cash($userid));
	// All's well, they can get this itel
	else
	{	
		//TODO add the database stuff to shop_db.php
		// Change item info (owner, amount paid, trading = not anymore)
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}shop_property
			SET userid = {int:userid}, amtpaid = {float:tradecost},
				trading = 0
			WHERE itemid = {int:id}
			LIMIT 1',
			array(
				'userid' => $context['user']['id'],
				'tradecost' => $row['tradecost'],
				'id' => $_GET['id'],
			));
		// Decrease user's money
		$final_value = $row['tradecost'] - $row['cash'];
        updateMemberData($context['user']['id'], array('cash' => $final_value));
	
	   //Update the member trade count
	   $final_value = $row['tradeHis'] + 1;
       updateMemberData($context['user']['id'], array('tradeHis' => $final_value));
		
	   // Give money to old owner
	   $final_value1 =  $row['tradecost'] + $row['cash'];
       updateMemberData($row['userid'], array('cash' => $final_value1));
		
		sendpm_trade();
			
		$context['shop_buy_message'] = sprintf($txt['shop_trade_bought_item'], $row['name'], $row['real_name']);
	}

	// Set the page title
	$context['page_title'] = $txt['shop_trade'];	
	// Use the message template
	$context['sub_template'] = 'message';
}
// If they're selling an item in the trade centre
elseif ($_REQUEST['sa'] == 'trade_sell')
{
	
	// Make sure ID was numeric
	$_GET['item'] = (int) $_GET['item'];
	//TODO add the database stuff to shop_db.php
	// Get information on the item
	$result = $smcFunc['db_query']('', '
		SELECT amtpaid
		FROM {db_prefix}shop_property
		WHERE id = {int:id}',
		array(
			'id' => $_GET['item'],
		));
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
	// The amount paid for the item
	$context['shop_paid'] = $row['amtpaid'];
	// Set the page title
	$context['page_title'] = $txt['shop_yourinv'];
	// Use the trade item sub template
	$context['sub_template'] = 'tradeItem';
}
// Sell an item - Part 2. Actually add the item to the trade centre
elseif ($_REQUEST['sa'] == 'trade_sell2')
{
		
	// Make sure certain values were numeric
	$_POST['id'] = (int) $_POST['id'];
	$_POST['sellfor'] = (int) $_POST['sellfor'];
	//TODO add the database stuff to shop_db.php
	// Check the owner of the item
	$result = $smcFunc['db_query']('', '
		SELECT userid
		FROM {db_prefix}shop_property
		WHERE id = {int:id}
		LIMIT 1',
		array(
			'id' => $_POST['id'],
		));

	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
	// Sell it for a negative amount? That very odd...
	if ($_POST['sellfor'] <= 0)
		$context['shop_buy_message'] = $txt['shop_trade_negative'];
	 // Sorry, stealing is illegal :P
	elseif ($row['userid'] !== $context['user']['id'])
		$context['shop_buy_message'] = $txt['shop_use_others_item'];
	else {
		//TODO add the database stuff to shop_db.php
		// Update item's information
		$result = $smcFunc['db_query']('', '
			UPDATE {db_prefix}shop_property
			SET trading = 1, 
				tradecost = {float:tradecost}
			WHERE id = {int:id}
			LIMIT 1',
			array(
				'tradecost' => $_POST['sellfor'],
				'id' => $_POST['id'],
			));
		$context['shop_buy_message'] = $txt['shop_trade_success'];
	}
	// Set the page title
	$context['page_title'] = $txt['shop_yourinv'];
	// Use the message template
	$context['sub_template'] = 'message';
	
}
// Stop trading an item
elseif ($_REQUEST['sa'] == "trade_stop")
{
	
	// Make sure ID was numeric
	$_GET['item'] = (int) $_GET['item'];
	//TODO add the database stuff to shop_db.php
	// Get the ownerID of the item
	$result = $smcFunc['db_query']('', '
		SELECT userid
		FROM {db_prefix}shop_property
		WHERE id = {int:id}
		LIMIT 1',
		array(
			'id' => $_GET['item'],
		));

	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
	// Sorry, stealing isn't allowed here!
	if ($row['userid'] !== $context['user']['id'])
		$context['shop_buy_message'] = $txt['shop_use_others_item'];
	else {
		//TODO add the database stuff to shop_db.php
		// Cancel the trade centre stuff
		$result = $smcFunc['db_query']('', '
			UPDATE {db_prefix}shop_property
			SET trading = 0, tradecost = 0
			WHERE id = {int:id}
			LIMIT 1',
			array(
				'id' => $_GET['item'],
			));
		// Tell the user what we did
		$context['shop_buy_message'] = $txt['shop_trade_cancelled'];
	}

	// Set the page title
	$context['page_title'] = $txt['shop_yourinv'];
	// Use the message template
	$context['sub_template'] = 'message';
}	  

	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=trade',
		'name' => $txt['shop_tab_trade'],
		);

}

function shop_owners() 
{
 global $context, $smcFunc, $scripturl, $shop, $txt;
 
// Make sure item ID is a number
		$_GET['users'] = (int) $_GET['users'];

		//TODO add the database stuff to shop_db.php
		$result =  $smcFunc['db_query']('','
			SELECT name
			FROM {db_prefix}shop_item
			WHERE itemid = {int:users}
			LIMIT 1',
			array(
			'users' => $_GET['users'],
				)
			);
	

		$row = $smcFunc['db_fetch_assoc']($result);
		$smcFunc['db_free_result']($result);

		//TODO add the database stuff to shop_db.php
		$result = $smcFunc['db_query']('','
			SELECT DISTINCT m.real_name
			FROM {db_prefix}shop_property AS inv
			INNER JOIN {db_prefix}shop_item AS it 
			INNER JOIN {db_prefix}members AS m ON (m.id_member = inv.userid)
			WHERE inv.itemid = {int:users}',
			array(
			'users' => $_GET['users'],
				)
			);
			
		//Show how many users own the item
		$context['shop_buy_message'] = '' . sprintf($txt['shop_users_own_item'], (int) $smcFunc['db_num_rows']($result), $row['name']).'<br />';
		while ($rowUser = $smcFunc['db_fetch_assoc']($result))

		// Now show the actual members
		$context['shop_buy_message'] .= '<br />' . $rowUser['real_name'];
		
		$smcFunc['db_free_result']($result);

		$context['shop_buy_message'] .= '';
		// Set the page title
	    $context['page_title'] = $txt['shop_owners'] . ' - ' . $row['name'];
		// Use the message template
		$context['sub_template'] = 'message';
		
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=buy',
		'name' => $txt['shop_owners'],
		);
		
	}

function Shop_Game() {

	global $sourcedir, $scripturl, $context, $txt;
	
	// Add it to the linktree
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=shop;sa=gamesroom',
		'name' => $txt['shop_tab_gr'],
		);
	
	require_once($sourcedir . '/shop2/Shop_Games.php');
	Game();

}

?>