<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://www.sa-mods.info
 *
 * The Initial Developer of the Original Code is
 * wayne Mankertz.
 * Portions created by the Initial Developer are Copyright (C) 2009-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):Danial15
 *
 * ***** END LICENSE BLOCK ***** */
if (!defined('SMF'))
	die('Hacking attempt...');

function shop_array_insert(&$input, $key, $insert, $where = 'before', $strict = false)
{
	$position = array_search($key, array_keys($input), $strict);
	
	// Key not found -> insert as last
	if ($position === false)
	{
		$input = array_merge($input, $insert);
		return;
	}
	
	if ($where === 'after')
		$position += 1;

	// Insert as first
	if ($position === 0)
		$input = array_merge($insert, $input);
	else
		$input = array_merge(
			array_slice($input, 0, $position, true),
			$insert,
			array_slice($input, $position, null, true)
		);
}
function Shop_actions(&$actionArray)
{
	global $modSettings;
	
	if (!empty($modSettings['enableshop']))
		return;
	
	$actionArray['shop'] = array('shop2/Shop.php', 'shop');
}

/*function Affiliate_core_features(&$core_features)
{
	$core_features['affiliate'] = array(
		'url' => 'action=admin;area=affiliates',
		'settings' => array(
			'enable_affiliates' => 1,
		),
	);
}*/

function Shop_load_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	global $context;
	
	$permissionList['membergroup'] += array(
		'view_shop' => array(false, 'shop', 'shop'),
		'view_gameroom' => array(false, 'shop', 'shop'),
		'view_trade' => array(false, 'shop', 'shop'),
		'view_bank' => array(false, 'shop', 'shop'),
		'view_gift' => array(false, 'shop', 'shop'),
		'view_othersinv' => array(false, 'shop', 'shop'),
		'view_buy' => array(false, 'shop', 'shop'),
		'manage_shop' => array(false, 'shop', 'shop'),
	);
	
	$context['non_guest_permissions'] = array_merge(
		$context['non_guest_permissions'],
		array(
		'view_shop',
		'view_gameroom',
		'view_trade',
		'view_bank',
		'view_gift',
		'view_othersinv',
		'view_buy',
		'manage_shop',
		)
	);
}

function Shop_menu_buttons(&$menu_buttons)
{
	global $context, $modSettings, $scripturl, $txt;
	
	
	shop_array_insert($menu_buttons, 'search',
		array(
			'shop' => array(
				'title' => $txt['shop_tab_main'],
				'href' => $scripturl . '?action=shop',
				'show' =>  true,
				'sub_buttons' => array(
				'admin' => array(
						'title' => $txt['shop_adminmm2'],
						'href' => $scripturl . '?action=admin;area=shop',
						'show' => allowedTo('manage_shop'),
					),
				),
				'active_button' => false,
			),
		)
	);
}

function Shop_admin_areas(&$admin_areas)
{
	global $context, $modSettings, $scripturl, $txt;
	
	loadlanguage('Shop');
	
	shop_array_insert($admin_areas, 'layout',
		array(
			
			'shop' => array(
			'title' => $txt['shop_shop2'],
			'permission' => array('manage_shop'),
			'areas' => array(
				'shop' => array(
					'label' => $txt['shop_shop2'],
					'file' => 'shop2/ShopAdmin.php',
					'function' => 'shopAdmin',
					'custom_url' => $scripturl . '?action=admin;area=shop',
					'icon' => 'server.gif',
					'permission' => array('manage_shop'),
					'subsections' => array(
					'info' => array($txt['shop_info']),
					'settingsa' => array($txt['MainSettings']),
						'inventory' => array($txt['shop_admin_invent']),
						'item' => array($txt['itemsssss']),
						'add' => array($txt['AddItems']),
						'cats' => array($txt['shop_admin_catlist']),
						'maintenace' => array($txt['shop_mainten']),
						
					),
				),
			),
		),
	)
	);
}

/* DUH! WINNING! */
function SaShop_Who()
{
		global $modSettings;
		
		$SASHOP = '<a href="http://smfhispano.org">SA Shop ' . $modSettings['shop_version'] . '</a>';

		return $SASHOP;
}

//Ultimas actualizaciones
function GetSAShopNews()
{
	global $sourcedir;
	
	//I need this file
	require_once($sourcedir.'/Subs-Package.php');
	
	//Load from our site
	$news = fetch_web_data("http://www.smfhispano.org/Mnews/SA_Shop/news.txt");
	
	echo $news;
}

function getCurrentversionSAShop()
{
	global $sourcedir;
	
	//Load again -.-
	require_once($sourcedir.'/Subs-Package.php');
	$version = fetch_web_data("http://smfhispano.org/Mnews/SA_Shop/version.txt");
	
	return $version;
}

?>