<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://www.sa-mods.info
 *
 * The Initial Developer of the Original Code is
 * wayne Mankertz.
 * Portions created by the Initial Developer are Copyright (C) 2009-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):Danial15
 *
 * ***** END LICENSE BLOCK ***** */

// If not in smf then this could be a hacking attempt?
if (!defined('SMF'))
      die('Hacking attempt...');
	  
function send_get_items()
{
	global $context, $user_info, $smcFunc;
	
	// Get all the user's current items
	$result = $smcFunc['db_query']('',"
		SELECT it.name, inv.id AS ivid, inv.trading
		FROM {db_prefix}shop_property AS inv
		INNER JOIN {db_prefix}shop_item AS it ON (inv.itemid = it.itemid)
		WHERE inv.userid = {int:key} AND inv.trading = 0
		GROUP BY it.itemid
		ORDER BY it.name ASC ",
			array(
			'key' => $user_info['id'],
				)
			);				
	// Loop through all the items...
	while ($row = $smcFunc['db_fetch_assoc']($result))
		// ...and add them to the list
		$context['shop_send_items'][] = array(
			'id' => $row['ivid'],
			'name' => $row['name']
		);
	$smcFunc['db_free_result']($result);
			
}

// Fix all the item category counts. Use this when the counts are incorrect
function recountItems()
{
	global $smcFunc;
	
	// Start with an empty count array
	$counts = array();
	
	// Get all the items
	$result = $smcFunc['db_query']('','
		SELECT catid
		FROM {db_prefix}shop_item',
			array(
			
				)
			);
	
	// Loop through them
	while ($row = $smcFunc['db_fetch_assoc']($result))
		// Is it categorised at all?
		if ($row['catid'] != 0)
			// Add one to the category's count. If it's not defined yet, set it to 1
			$counts[$row['catid']] = (isset($counts[$row['catid']]) ? $counts[$row['catid']] + 1 : 1);
		
	$smcFunc['db_free_result']($result);
	
	// Loop through all the categories
	foreach ($counts as $key => $value)
		// Update this category's count
		$smcFunc['db_query']('','
			UPDATE {db_prefix}shop_category
			SET count = {int:value}
			WHERE catid = {int:key}',
			array(
			'value' => $value,
			'key' => $key,	
				)
			);
			
}
	  
function hasgamePass()
{
	global $smcFunc,  $context, $modSettings, $user_info;
    
	$nameid = $context['user']['id'];
	
	// Check for an arcade pass
	$result = $smcFunc['db_query']('', '
		SELECT m.games_pass
		FROM {db_prefix}members AS m
		WHERE m.id_member = {int:userid} 
		LIMIT 1',
			array(
			'userid' => $nameid,
				)
			);

	// check to see if the pass has expired
	$pass = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	if (time() < $pass["games_pass"])
	{
		return true;
	}
	
	// pass has expired, return false
	return false;
}

function shop_stats() {

global $user_info, $scripturl, $context, $affiliates_request, $smcFunc;

	//Total Items in the shop
	$result = $smcFunc['db_query']('', '
	SELECT
		COUNT(*) AS itemid
	FROM {db_prefix}shop_item',
			array(
				
				)
			);
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);

	$context['total_items'] = $row['itemid'];
	
	//Total Items Sold
	$result = $smcFunc['db_query']('', '
	SELECT
		SUM(sold) AS sold,
		COUNT(*) AS total
	FROM {db_prefix}shop_item',
			array(
				
				)
			);
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);

	$context['total_sold'] = $row['sold'];
	
	//Top Purchesers
	$result =  $smcFunc['db_query']('', '
	SELECT id_member, real_name, purchHis
	FROM {db_prefix}members
	ORDER BY purchHis DESC, real_name
	LIMIT 10',
			array(
				
				)
			);
	$context['top_purchesers'] = array();
	$max_views = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['top_purchesers'][] = array(
			'id_member' => $row['id_member'],
				'real_name' => $row['real_name'],
				'purchHis' => $row['purchHis']
		);

		if ($max_views < $row['purchHis'])
			$max_views = $row['purchHis'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['top_purchesers'] as $i => $file)
		$context['top_purchesers'][$i]['percent'] = round(($file['purchHis'] * 100) / $max_views);

	
	//Top Traders
	$result =  $smcFunc['db_query']('', '
	SELECT id_member, real_name, tradeHis
			FROM {db_prefix}members
			ORDER BY tradeHis DESC, real_name
			LIMIT 10',
			array(
				
				)
			);
	$context['top_trade'] = array();
	$max_views = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['top_trade'][] = array(
			'id_member' => $row['id_member'],
				'real_name' => $row['real_name'],
				'tradeHis' => $row['tradeHis']
		);

		if ($max_views < $row['tradeHis'])
			$max_views = $row['tradeHis'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['top_trade'] as $i => $file)
		$context['top_trade'][$i]['percent'] = round(($file['tradeHis'] * 100) / $max_views);

	//Richest members Pocket
	$result = $smcFunc['db_query']('', '
	SELECT id_member, real_name, cash
			FROM {db_prefix}members
			ORDER BY cash DESC, real_name
			LIMIT 10',
			array(
				
				)
			);
	$context['top_cash'] = array();
	$max_views = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['top_cash'][] = array(
			'id_member' => $row['id_member'],
				'real_name' => $row['real_name'],
				'cash' => $row['cash']
		);

		if ($max_views < $row['cash'])
			$max_views = $row['cash'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['top_cash'] as $i => $file)
		$context['top_cash'][$i]['percent'] = round(($file['cash'] * 100) / $max_views);
	
	
	//Richest Members Bank
	$result = $smcFunc['db_query']('', '
	SELECT id_member, real_name, cashBank
			FROM {db_prefix}members
			ORDER BY cashBank DESC, real_name
			LIMIT 10',
			array(
				
				)
			);
	$context['top_cashbank'] = array();
	$max_views = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['top_cashbank'][] = array(
			'id_member' => $row['id_member'],
				'real_name' => $row['real_name'],
				'cashbank' => $row['cashBank']
		);

		if ($max_views < $row['cashBank'])
			$max_views = $row['cashBank'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['top_cashbank'] as $i => $file)
		$context['top_cashbank'][$i]['percent'] = round(($file['cashbank'] * 100) / $max_views);
}
	  
function shop_mainv() {
	
	global  $smcFunc, $context;
	
	// Grab the purchase history
		// Start with empty list
		$context['shop_purch'] = array();
		// Get the details of purchases
		$request = $smcFunc['db_query']('', '
			SELECT id_member, real_name, purchHis
			FROM {db_prefix}members
			ORDER BY purchHis DESC, real_name
			LIMIT 10',
			array(
			
				)
			);
		// Loop through all results
	while ($row = $smcFunc['db_fetch_assoc']($request))
			// And add them to the list
			$context['shop_purch'][] = array(
				'ID_MEMBER' => $row['id_member'],
				'realName' => $row['real_name'],
				'purchHis' => $row['purchHis']	
			);
			
		$smcFunc['db_free_result']($request);
	
		// Grab the purchase history
		// Start with empty list
		$context['shop_tradeHis'] = array();
		// Get the details of purchases
		$request = $smcFunc['db_query']('', '
			SELECT id_member, real_name, tradeHis
			FROM {db_prefix}members
			ORDER BY tradeHis DESC, real_name
			LIMIT 10',
			array(
			
				)
			);
		// Loop through all results
	while ($row = $smcFunc['db_fetch_assoc']($request))
			// And add them to the list
			$context['shop_tradeHis'][] = array(
				'ID_MEMBER' => $row['id_member'],
				'realName' => $row['real_name'],
				'tradeHis' => $row['tradeHis']
			);
			
		$smcFunc['db_free_result']($request);
	
		// Grab the purchase history
		// Start with empty list
		$context['shop_purchHis'] = array();
		// Get the details of purchases
		$request = $smcFunc['db_query']('', '
			SELECT pu.userid, pu.itemid, pu.amtpaid, it.description, it.sold, it.name, it.description, it.catid, it.image, it.itemid
			FROM {db_prefix}shop_purchHis AS pu 
			INNER JOIN {db_prefix}shop_item AS it ON (pu.itemid = it.itemid)		
			ORDER BY pu.id DESC
			LIMIT 4',
			array(
			
				)
			);
		// Loop through all results
	while ($row = $smcFunc['db_fetch_assoc']($request))
			// And add them to the list
			$context['shop_purchHis'][] = array(
				'ownerid' => $row['userid'],
				'catid' => $row['catid'],
				'itemid' => $row['itemid'],
				'amtpaid' => $row['amtpaid'],
				'desc' => $row['description'],
				'name' => $row['name'],
				'image' => $row['image'],
				'description' => $row['description'],
                'sold' => $row['sold']			
			);
			
		$smcFunc['db_free_result']($request);
	
	$context['shop_sold'] = array();
		// Get the details of purchases
		$request = $smcFunc['db_query']('', '
			SELECT it.sold, it.description, it.image, it.catid, it.itemid, it.name
			FROM {db_prefix}shop_item AS it 
			ORDER BY it.sold DESC
			LIMIT 4',
			array(
			
				)
			);
		// Loop through all results
	while ($row = $smcFunc['db_fetch_assoc']($request))
			// And add them to the list
			$context['shop_sold'][] = array(
				'sold' => $row['sold'],
				'catid' => $row['catid'],
				'name' => $row['name'],
				'itemid' => $row['itemid'],
				'description' => $row['description'],
				'image' => $row['image']	
			);
			
		$smcFunc['db_free_result']($request);
		
		// 10 richest people (pocket)
		// Start with empty list
		$context['shop_richest'] = array();
		// Get the richest people
		$result = $smcFunc['db_query']('', '
			SELECT id_member, real_name, cash
			FROM {db_prefix}members
			WHERE cash <> 0
			ORDER BY cash DESC, real_name
			LIMIT 10',
			array(
			
				)
			);
		// Loop through all results
			while ($row = $smcFunc['db_fetch_assoc']($result)) 
			// And add them to the list
			$context['shop_richest'][] = array(
				'id_member' => $row['id_member'],
				'real_name' => $row['real_name'],
				'cash' => $row['cash']
			);
			
		$smcFunc['db_free_result']($result);

		// 10 richest people (pocket)
		// Again, let's start with an empty list
		$context['shop_richestBank'] = array();
		// Get the richest people
		$result = $smcFunc['db_query']('', '
			SELECT id_member, real_name, cashBank
			FROM {db_prefix}members
			WHERE cashBank <> 0
			ORDER BY cashBank DESC, real_name
			LIMIT 10',
			array(
			
				)
			);
		// Loop through all results
			while ($row = $smcFunc['db_fetch_assoc']($result)) 
			// Add them to the list
			$context['shop_richestBank'][] = array(
				'id_member' => $row['id_member'],
				'real_name' => $row['real_name'],
				'cashBank' => $row['cashBank']
			);
			
		$smcFunc['db_free_result']($result);

}	  

function shop_CashBank($userid, $cashBank) {
	
	global  $user_info, $smcFunc;

	updateMemberData($userid, array('cashBank' => $cashBank));
			
}	  
function shop_iteminfo($itemid, $id) {
	global $smcFunc, $context;
	
	if($itemid <> '')
	{
		$result = $smcFunc['db_query']('', '
			SELECT price, count, sold
			FROM {db_prefix}shop_item
			WHERE itemid = {int:itemid}',
			array(
				'itemid' => $itemid,
				)
			);
			
		while ($row = $smcFunc['db_fetch_assoc']($result))
		{
			$temp = array(
				'price' => $row['price'],
				'count' => $row['count'],
				'sold' => $row['sold']
			);
		}
		
		return $temp;
	}
	
	if($id > 0)
	{
		$result = $smcFunc['db_query']('', '
			SELECT itemid
			FROM {db_prefix}shop_property
			WHERE id = {int:id}',
			array(
				'id' => $id,
				)
			);
		
		$row = $smcFunc['db_fetch_assoc']($result);
		
		return $row['itemid'];
	}
}

function shop_readCat() {
	global $db_prefix, $smcFunc;
	
	$temp = array();
	
	$result =  $smcFunc['db_query']('', '
		SELECT catid, count, name, image, `description`
		FROM {db_prefix}shop_category
		ORDER BY `catid` ASC',
			array(
			
				)
			);
	while ($row = $smcFunc['db_fetch_assoc']($result)) 
	{
		$temp[$row['catid']] = array (
			'name' => $row['name'],
			'catid' => $row['catid'],
			'count' => $row['count'],
			'image' => $row['image'],
		);
	}
	$smcFunc['db_free_result']($result);
	return $temp;
}

function shop_Cash($userid) {
	global $smcFunc;
	
	$result = $smcFunc['db_query']('', '
				SELECT cash 
				FROM {db_prefix}members 
				WHERE id_member = {int:userid}
				LIMIT 1',
			array(
			'userid' => $userid,
				)
			);
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	return $row['cash'];
}
function shop_doCash($userid, $cash) {
	global $smcFunc;
	
	updateMemberData($userid, array('cash' => $cash));
		
}
function shop_saveitems($userid, $itemid, $todo, $count, $comment) {
	global $smcFunc, $iteminfo, $user_info, $db_prefix;
	
	if($userid == '')
	{
		if($todo == 'minus')
		{
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}shop_item
				SET	count = count - {int:count}
				WHERE itemid = {int:itemid}',
			array(
			'count' => $count,
			'itemid' => $itemid,
				)
			);
		}
		elseif($todo == 'sold')
		{
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}shop_item
				SET	sold = sold + 1
				WHERE itemid = {int:itemid}',
			array(
			
			'itemid' => $itemid,
				)
			);
			
		}
		
	
		elseif($todo == 'plus')
		{
			
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}shop_item
				SET	count = count + {int:count}
				WHERE itemid = {int:itemid}',
			array(
			'count' => $count,
			'itemid' => $itemid,
				)
			);
		}
		elseif($todo == 'update')
		{
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}shop_item
				SET	count = {int:count}
				WHERE itemid = {int:itemid}
				LIMIT 1',
			array(
			'count' => $count,
			'itemid' => $itemid,
				)
			);
		}
		
	}
	else
	{
		if($todo == 'add')
		{
			
        $iteminfo = shop_iteminfo($itemid,'');
		
				
			$smcFunc['db_insert']('',
				'{db_prefix}shop_property',
				array('userid' => 'string', 'itemid' => 'string', 'comment' => 'string', 'amtpaid' => 'string'),
				array($userid, $itemid, $comment, $iteminfo['price']),
				array()
			);
		}
		elseif($todo == 'purchhism')
		{
			// Insert into purchase history
		$smcFunc['db_insert']('',
				'{db_prefix}shop_purchHis',
				array('userid' => 'string', 'itemid' => 'string', 'amtpaid' => 'string'),
				array($userid, $itemid, $iteminfo['price']),
				array()
				);
		}
		elseif($todo == 'purchhismember')
		{
		$iteminfo = shop_iteminfo($itemid,'');	
		
			$result = $smcFunc['db_query']('','
				SELECT purchHis 
				FROM {db_prefix}members 
				WHERE id_member = {int:userid}
				LIMIT 1',
			array(
			'userid' => $userid,
				)
			);
	$row =  $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	
			$final_value4 =  $row['purchHis'] + $iteminfo['price'];
        updateMemberData($userid, array('purchHis' => $final_value4));
			
		}
		elseif($todo == 'remove')
		{
			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}shop_property
				WHERE id =  {int:itemid}
			',
			array(
			'itemid' => $itemid,
				)
			);
		}
	}
}

function shop_fetchitems($userid, $cat){
	global $smcFunc, $scripturl, $puppys, $db_prefix, $context;
	
	if ($userid <> '')
	{
		// Start the temp array
		$temp = array();
		
		$result = $smcFunc['db_query']('', '
			SELECT itemid, name, `description`, price, count, image, input_needed
			FROM {db_prefix}shop_item',
			array(
			
				)
			);
			
		while ($row = $smcFunc['db_fetch_assoc']($result))
		{
			$temp[$row['itemid']] = array(
				'image' => $row['image'],
				'name' => $row['name'],
				'description' => $row['description'],
				'price' => $row['price'],
				'input_needed' => $row['input_needed'],
				);
		}

		$items = array();
        
		// Get the total items in the users inv
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}shop_property
		WHERE userid = {int:userid}
		',
			array(
			
			'userid' => $userid,
				)
			);

	list ($puppys) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	
	if(isset($_SESSION['just_posted_name']) == true){
	// Now create the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=shop;sa=inventory;next2='.isset($_SESSION['name_posted']).';sort=' . $_REQUEST['start'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $puppys, 10);
	$context['start'] = $_REQUEST['start'];
	$_SESSION['just_posted_name'] = false;
	}
	else{
	// Now create the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=shop;sa=inventory;sort=' . $_REQUEST['start'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $puppys, 10);
	$context['start'] = $_REQUEST['start'];
	}
	if(isset($_REQUEST['area']) == 'shop'){
	// Now create the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=admin;area=shop;sa=inventory;next2='.$_SESSION['name_posted_admin'].';sort=' . $_REQUEST['start'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $puppys, 10);
	$context['start'] = $_REQUEST['start'];
	}
	
		// Now we need the items in the users inventory
		$result =  $smcFunc['db_query']('', '
			SELECT itemid, id, comment, trading, tradecost
			FROM {db_prefix}shop_property
			WHERE userid = {int:userid}
			LIMIT {int:start}, 10
			',
			array(
			'start' => $context['start'],
			'userid' => $userid,
				)
			);
		
		while($row = $smcFunc['db_fetch_assoc']($result))
		{
			$items[$row['id']] = array(
				'itemid' => $row['itemid'],
				'comment' => $row['comment'],
				'trading' => $row['trading'],
				'tradecost' => $row['tradecost']
			);
		}
		
		foreach ($items as $id => $each)
		{
			$new = $items[$id]['itemid'];
			$items[$id]['image'] = $temp[$new]['image'];
			$items[$id]['name'] = $temp[$new]['name'];
			$items[$id]['description'] = $temp[$new]['description'];
			$items[$id]['price'] = $temp[$new]['price'];
			$items[$id]['input_needed'] = $temp[$new]['input_needed'];
		}
		$smcFunc['db_free_result']($result);
		return ($items);
	}
	
	else
	{
		$items = array();
		$temp = array();

		// Get the total item in the shop
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}shop_item
		WHERE catid = {int:cat}
		',
			array(
			'cat' => $cat,
			)
		);

	list ($kittens) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	
	// Now create the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=shop;sa=buy;cat='.$cat.';sort=' . $_REQUEST['start'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $kittens, 10);
	$context['start'] = $_REQUEST['start'];
	
		// Now we need our items
		$result = $smcFunc['db_query'] ('','
			SELECT itemid, name, `description`, price, count, image, catid, status, input_needed, sold
			FROM {db_prefix}shop_item
			WHERE catid = {int:cat}
			ORDER BY name DESC
			LIMIT {int:start}, 10',
			array(
			'cat' => $cat,
			'start' => $context['start'],
			)
		);
			
			
		while ($row = $smcFunc['db_fetch_assoc']($result))
		{
			$items[$row['itemid']] = array(
				'image' => $row['image'],
				'sold' => $row['sold'],
				'name' => $row['name'],
				'description' => $row['description'],
				'price' => $row['price'],
				'count' => $row['count'],
				'catid' => $row['catid'],
				'status' => $row['status'],
				'input_needed' => $row['input_needed'],
				);
		}
		
		$smcFunc['db_free_result']($result);
		return ($items);
	}
}

function shop_own($userid, $id) {
	global $smcFunc;
	
	$request = $smcFunc['db_query'] ('','
		SELECT COUNT(id)
		FROM {db_prefix}shop_property
		WHERE userid = {int:userid} AND id = {int:id}',
			array(
			'id' => $id,
			'userid' => $userid,
				)
			);
	list ($totals) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	return $totals;
	
}

function shop_doCashBank($userid) {
	global $context, $smcFunc;
		
	$result = $smcFunc['db_query']('','
				SELECT cashBank 
				FROM {db_prefix}members 
				WHERE id_member = {int:userid}
				LIMIT 1',
			array(
			'userid' => $userid,
				)
			);
	$row =  $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	return $row['cashBank'];
}
	

function shop_UserId($nameid) {
	global $context, $smcFunc;

	$result = $smcFunc['db_query']('','
		SELECT id_member
		FROM {db_prefix}members
		WHERE member_name = {string:nameid}
		LIMIT 1',
			array(
			'nameid' => $nameid,
				)
			);;

	$row =  $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	return $row['id_member'];
}

function shop_restock() {
	global  $smcFunc;
	
	$less = !empty($_POST['lessthan']) ? (int) $_POST['lessthan'] : 0;
	$amount = !empty($_POST['amount']) ? (int) $_POST['amount'] : 0;
	
	$smcFunc['db_query']('', '
				UPDATE {db_prefix}shop_item
				SET
				count = count + {int:count}
				WHERE count < {int:count2}',
			array(
				'count2' => $less,
				'count' => $amount,
					
				)
			);
}

function shop_getcatid() {
	global  $smcFunc;
	
	$result = $smcFunc['db_query']('', '
				SELECT catid 
				FROM {db_prefix}shop_item
                ORDER BY catid ASC',
			array(
			
				)
			);
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);
	return $row;
}


function shopcatlist() {
	global $cats, $smcFunc;
	
	$cats = array();
	// Get all the categories
	$result = $smcFunc['db_query']('','
		SELECT catid, name, image, count, description
		FROM {db_prefix}shop_category
		ORDER BY name ASC',
			array(
				)
			);
	// Loop through all the categories
	while ($row =  $smcFunc['db_fetch_assoc']($result))
		// Let's add this to our array
		$cats[] = array(
			'catid' => $row['catid'],
			'name' => $row['name'],
			'image' => $row['image'],
			'count' => $row['count'],
			'description' => $row['description'],
		);
	$smcFunc['db_free_result']($result);
	
	// Return the array
	return $cats;

}

?>