<?php

/**********************************************************************************
* SMFShop item                                                                    *
***********************************************************************************
* SMFShop: Shop MOD for Simple Machines Forum                                     *
* =============================================================================== *
* Software Version:           SMFShop 3.0 (Build 12)                              *
* Software by:                DanSoft Australia (http://www.dansoftaustralia.net/)*
* Copyright 2005-2007 by:     DanSoft Australia (http://www.dansoftaustralia.net/)*
* Support, News, Updates at:  http://www.dansoftaustralia.net/                    *
*                                                                                 *
* Forum software by:          Simple Machines (http://www.simplemachines.org)     *
* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
*           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the provided license as published by Simple Machines LLC.          *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* See the "license.txt" file for details of the Simple Machines license.          *
* The latest version of the license can always be found at                        *
* http://www.simplemachines.org.                                                  *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

// Your class should always be called item_filename, eg. if your file is 
// myCoolItem.php then the class should be called 'item_myCoolItem'. This 
// class should always extend itemTemplate.
class item_gamespass extends itemTemplate
{
	// When this function is called, you should set all the item's
	// variables (see inside this example)
	function getItemDetails()
	{
		// The author of the item
		$this->authorName = 'wdm2005';

		// The author's website
		$this->authorWeb = 'http://sleepy-arcade.ath.cx/';

		// And their email address
		$this->authorEmail = 'wdm2005@blueyonder.co.uk';

		// VALUES CHANGEABLE FROM WITHIN ADMIN PANEL:
		// The name of the item
		$this->name = 'Games Room Pass xxx days';

		// The item's description
		$this->desc = 'Allows access to Games Room for xxx days';

		// The item's price
		$this->price = 50;

		$this->require_input = false;
		$this->can_use_item = true;
		$this->addInput_editable = true;
	}

	function getAddInput()
	{
		global $item_info;

		if ($item_info[1] == 0) $item_info[1] = 30;
		return 'Days until games room pass expires: <input type="text" name="info1" value="' . $item_info[1] . '" />';
	}

	function onUse()
	{
		global $smcFunc, $user_info, $item_info;

		$days = 86400 * $item_info[1];
		$time = time() + $days;
		
		updateMemberData($user_info['id'], array('games_pass' =>  $time));
		
		return 'Successfully set games room pass to expire in ' . $item_info[1] . ' days!';
	}
}

?>

